<?php

class WindDoc_Winddocapp_Helper_Data extends Mage_Core_Helper_Abstract
{
  private $root_login = 'https://app.winddoc.com/oauth-login.php?token_app=9bf918870cb006ebb2a831a1e9e689657d5164f3e7e40add00bbfb743434c52f';
  private $root = 'https://app.winddoc.com';


  public function getRootLogin(){
    return $this->root_login;
  }
  public function getRoot(){
    return $this->root;
  }

  public function getConfig($configPath, $storeId=null){
      if($storeId == null){
          if (strlen($code = Mage::getSingleton('adminhtml/config_data')->getStore())){
            $storeId = Mage::getModel('core/store')->load($code)->getId();
          }else if (strlen($code = Mage::getSingleton('adminhtml/config_data')->getWebsite())){
            $websiteId = Mage::getModel('core/website')->load($code)->getId();
            $storeId = Mage::app()->getWebsite($websiteId)->getDefaultStore()->getId();
          }else{
            $storeId = 0;
          }
      }

      return Mage::getStoreConfig($configPath, $storeId);
  }

  public function getConti(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getConti();
    $ret = array();
    $ret["no"] = "No";
    $ret["predefinito"] = "Prefedinito";

    if(count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";
        foreach ($value as $v) {
          if($v->name=="id_conto"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }
    return $ret;
  }

  public function getTemplateInvoice(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getTemplateInvoice();
    $ret = array();
    $ret["predefinito"] = "Predefinito";
    if(count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";
        foreach ($value as $v) {
          if($v->name=="id_templatestampa"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }
    return $ret;
  }


  public function getTemplateRicevute(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getTemplateRicevute();
    $ret = array();
    $ret["predefinito"] = "Predefinito";
    if(count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";
        foreach ($value as $v) {
          if($v->name=="id_templatestampa"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }
    return $ret;
  }


  public function getTemplateQuote(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getTemplateQuote();
    $ret = array();
    $ret["predefinito"] = "Predefinito";
    if(count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";
        foreach ($value as $v) {
          if($v->name=="id_templatestampa"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }
    return $ret;
  }

  public function creaOrdine($order){
    //Verifico se devo salvare il cliente
    if(Mage::helper('winddocapp')->getConfig("winddoc/contatti/sincronizza_contatto")==1){
      $id_contatto = $this->sincroCustomerByOrder($order);
      $order->setIdCustomerWinddoc($id_contatto);
    }

    $data = $this->getDataFromOrder($order,"ordini");
    unset($data["cointestatario"]);
    $WindDocTalker = new WindDocTalker();
    $url = $WindDocTalker->sendDocument($data,$data["document_type"]);

    return $url;
  }

  public function creaFattura($order){
    //Verifico se devo salvare il cliente
    if(Mage::helper('winddocapp')->getConfig("winddoc/contatti/sincronizza_contatto")==1){
      $id_contatto = $this->sincroCustomerByOrder($order);
      $order->setIdCustomerWinddoc($id_contatto);
    }

    $data = $this->getDataFromOrder($order,"fatture");

    $det = Mage::helper('winddocapp')->dettaglioOrdine($order->getId());
    if(isset($det["id_ordine_winddoc"]) && $det["id_ordine_winddoc"]!=""){
      $data["relation"][0]["parent_type"] = "ordini";
      $data["relation"][0]["parent_id"] = $det["id_ordine_winddoc"];
    }

    //verifico se devo inviare l'email
    if(Mage::helper('winddocapp')->getConfig("winddoc/fatture/send_email")==1){
      $data["send_email"] = true;
    }
    $WindDocTalker = new WindDocTalker();
    $url = $WindDocTalker->sendDocument($data,$data["document_type"]);

    return $url;
  }

  public function sincroCustomerByOrder($order){
    //Verifico se il cliente è già sincronizzato


    $ret = $this->dettaglioSincroCustomer($order->getCustomerId());

    //Ricerco clienti

    if(isset($ret["id_customer_winddoc"]) && $ret["id_customer_winddoc"]!=""){
      return $ret["id_customer_winddoc"];
    }else{
      //Aggiunco cliente
      $indirizzo_fatturazione = $order->getBillingAddress();
      $indirizzo_spedizione = $order->getShippingAddress();
      $data = array();
      $data["tipo_contatto"] = 1;//tipo contatto lo impostiamo come cliente

      if($indirizzo_fatturazione->getVatId()=="" || strlen(trim($indirizzo_fatturazione->getVatId())) == 16){
        //E' un privato
        $data["nome"] = trim($indirizzo_fatturazione->getFirstname());
        $data["cognome"] = trim($indirizzo_fatturazione->getLastname());
        $data["codice_fiscale"] = $indirizzo_fatturazione->getCodicefiscale();
        $data["ragione_sociale"] = "";
        $data["indirizzo_citta"] = $this->array_to_string($indirizzo_fatturazione->getCity());
        $data["indirizzo_nazione"] = $this->array_to_string($indirizzo_fatturazione->getCountryId());
        $data["indirizzo_cap"] = $this->array_to_string($indirizzo_fatturazione->getPostcode());
        $data["indirizzo_provincia"] = $this->array_to_string($indirizzo_fatturazione->getRegionCode());
        $data["indirizzo_via"] = $this->array_to_string($indirizzo_fatturazione->getStreet());
        $data["partita_iva"] = "";
        $data["email"] = $order->getCustomerEmail();
        $data["codice_destinatario"] = "0000000";
        $data["email_pec"] = "";
      }else{
        //è un'azienda
        $data["nome"] = trim($indirizzo_fatturazione->getFirstname()." ".$indirizzo_fatturazione->getLastname());
        if($data["nome"]==""){
          $data["nome"] = $indirizzo_fatturazione->getCompany();
        }
        $data["codice_fiscale"] = $indirizzo_fatturazione->getCodicefiscale();
        $data["ragione_sociale"] = $indirizzo_fatturazione->getCompany();
        $data["indirizzo_citta"] = $this->array_to_string($indirizzo_fatturazione->getCity());
        $data["indirizzo_nazione"] = $this->array_to_string($indirizzo_fatturazione->getCountryId());
        $data["indirizzo_cap"] = $this->array_to_string($indirizzo_fatturazione->getPostcode());
        $data["indirizzo_provincia"] = $this->array_to_string($indirizzo_fatturazione->getRegionCode());
        $data["indirizzo_via"] = $this->array_to_string($indirizzo_fatturazione->getStreet());
        $data["partita_iva"] = $indirizzo_fatturazione->getVatId();
        $data["email"] = $order->getCustomerEmail();
        $data["codice_destinatario"] = $indirizzo_fatturazione->getSdi();
        $data["email_pec"] = $indirizzo_fatturazione->getEmailPec();
      }

      $WindDocTalker = new WindDocTalker();


      $ret = $WindDocTalker->aggiungiModificaCustomer($data);
      //$ret = $WindDocTalker->aggiungiCustomer($data);

      $this->aggiungiSincroCustomer($order->getCustomerId(),$ret);
      return $ret;
    }

  }

  public function getDataFromOrder($order,$type=""){

    $data = array();
    $data["document_type"] = $type;
    if($type=="fatture"){
      $data["numerazione"] = Mage::helper('winddocapp')->getConfig("winddoc/fatture/numerazione");
    }
    if($type=="ricevute"){
      $data["numerazione"] = Mage::helper('winddocapp')->getConfig("winddoc/ricevute/numerazione");
    }
    if($type=="ordini"){
      $data["numerazione"] = Mage::helper('winddocapp')->getConfig("winddoc/ordini/numerazione");
    }
    $data["valuta"] = "e994378e-c24b-12e2-cb41-5717c48cdc99"; //Impostiamo di defaut €
    $indirizzo_fatturazione = $order->getBillingAddress();
    $indirizzo_spedizione = $order->getShippingAddress();
    if($order->getIdCustomerWinddoc()!=""){
      $data["id_contatto"] = $order->getIdCustomerWinddoc();
    }

    if($indirizzo_fatturazione->getVatId()=="" || strlen(trim($indirizzo_fatturazione->getVatId())) == 16){
      //E' un privato
      if($type=="fatture"){
        if(Mage::helper('winddocapp')->getConfig("winddoc/ricevute/sincronizza_ricevute")==1){
          $data["numerazione"] = Mage::helper('winddocapp')->getConfig("winddoc/ricevute/numerazione");
          $data["document_type"] = "ricevute";
          $type = "ricevute";
        }
      }
      $data["contatto_nome"] = trim($indirizzo_fatturazione->getFirstname());
      $data["contatto_cognome"] = trim($indirizzo_fatturazione->getLastname());
      $data["contatto_codice_fiscale"] = $indirizzo_fatturazione->getCodicefiscale();
      $data["contatto_ragione_sociale"] = "";
      $data["contatto_indirizzo_citta"] = $this->array_to_string($indirizzo_fatturazione->getCity());
      $data["contatto_indirizzo_nazione"] = $this->array_to_string($indirizzo_fatturazione->getCountryId());
      $data["contatto_indirizzo_cap"] = $this->array_to_string($indirizzo_fatturazione->getPostcode());
      $data["contatto_indirizzo_provincia"] = $this->array_to_string($indirizzo_fatturazione->getRegionCode());
      $data["contatto_indirizzo_via"] = $this->array_to_string($indirizzo_fatturazione->getStreet());


      $data["contatto_partita_iva"] = "";
      $data["contatto_email"] = $order->getCustomerEmail();
      $data["contatto_codice_destinatario"] = "0000000";
      $data["contatto_email_pec"] = "";
    }else{
      //è un'azienda
      $data["contatto_nome"] = trim($indirizzo_fatturazione->getFirstname()." ".$indirizzo_fatturazione->getLastname());
      if($data["contatto_nome"]==""){
        $data["contatto_nome"] = $indirizzo_fatturazione->getCompany();
      }
      $data["contatto_codice_fiscale"] = $indirizzo_fatturazione->getCodicefiscale();
      $data["contatto_ragione_sociale"] = $indirizzo_fatturazione->getCompany();
      $data["contatto_indirizzo_citta"] = $this->array_to_string($indirizzo_fatturazione->getCity());
      $data["contatto_indirizzo_nazione"] = $this->array_to_string($indirizzo_fatturazione->getCountryId());
      $data["contatto_indirizzo_cap"] = $this->array_to_string($indirizzo_fatturazione->getPostcode());
      $data["contatto_indirizzo_provincia"] = $this->array_to_string($indirizzo_fatturazione->getRegionCode());
      $data["contatto_indirizzo_via"] = $this->array_to_string($indirizzo_fatturazione->getStreet());
      $data["contatto_partita_iva"] = $indirizzo_fatturazione->getVatId();
      $data["contatto_email"] = $order->getCustomerEmail();
      $data["contatto_codice_destinatario"] = $indirizzo_fatturazione->getSdi();
      $data["contatto_email_pec"] = $indirizzo_fatturazione->getEmailPec();
    }

    if($indirizzo_spedizione != null){

      $df = $indirizzo_fatturazione->getData();
      $ds = $indirizzo_spedizione->getData();
      unset($df["entity_id"]);
      unset($ds["entity_id"]);
      unset($df["address_type"]);
      unset($ds["address_type"]);

      if(md5(serialize($ds)) != md5(serialize($df))){

        //Aggiungo secondo intestatario
        $data["cointestatario"][0] = array();
        if($indirizzo_spedizione->getVatId()=="" || strlen(trim($indirizzo_spedizione->getVatId())) == 16){
          //E' un privato
          $data["cointestatario"][0]["nome"] = trim($indirizzo_spedizione->getFirstname());
          $data["cointestatario"][0]["cognome"] = trim($indirizzo_spedizione->getLastname());
          $data["cointestatario"][0]["codice_fiscale"] = $indirizzo_spedizione->getCodicefiscale();
          $data["cointestatario"][0]["ragione_sociale"] = "";
          $data["cointestatario"][0]["indirizzo_citta"] = $this->array_to_string($indirizzo_spedizione->getCity());
          $data["cointestatario"][0]["indirizzo_nazione"] = $this->array_to_string($indirizzo_spedizione->getCountryId());
          $data["cointestatario"][0]["indirizzo_cap"] = $this->array_to_string($indirizzo_spedizione->getPostcode());
          $data["cointestatario"][0]["indirizzo_provincia"] = $this->array_to_string($indirizzo_spedizione->getRegionCode());
          $data["cointestatario"][0]["indirizzo_via"] = $this->array_to_string($indirizzo_spedizione->getStreet());
          $data["cointestatario"][0]["partita_iva"] = "";
          $data["cointestatario"][0]["email"] = "";
          $data["cointestatario"][0]["codice_destinatario"] = "0000000";
          $data["cointestatario"][0]["email_pec"] = "";
        }else{
          //è un'azienda
          $data["cointestatario"][0]["nome"] = trim($indirizzo_spedizione->getFirstname()." ".$indirizzo_spedizione->getLastname());
          if($data["cointestatario"][0]["nome"]==""){
            $data["cointestatario"][0]["nome"] = $indirizzo_spedizione->getCompany();
          }
          $data["cointestatario"][0]["codice_fiscale"] = $indirizzo_spedizione->getCodicefiscale();
          $data["cointestatario"][0]["ragione_sociale"] = $indirizzo_spedizione->getCompany();
          $data["cointestatario"][0]["indirizzo_citta"] = $this->array_to_string($indirizzo_spedizione->getCity());
          $data["cointestatario"][0]["indirizzo_nazione"] = $this->array_to_string($indirizzo_spedizione->getCountryId());
          $data["cointestatario"][0]["indirizzo_cap"] = $this->array_to_string($indirizzo_spedizione->getPostcode());
          $data["cointestatario"][0]["indirizzo_provincia"] = $this->array_to_string($indirizzo_spedizione->getRegionCode());
          $data["cointestatario"][0]["indirizzo_via"] = $this->array_to_string($indirizzo_spedizione->getStreet());
          $data["cointestatario"][0]["partita_iva"] = $indirizzo_spedizione->getVatId();
          $data["cointestatario"][0]["email"] = "";
          $data["cointestatario"][0]["codice_destinatario"] = "";
          $data["cointestatario"][0]["email_pec"] = "";
        }
      }
    }


    $totale = $order->getGrandTotal();
    $vatAmount = $order->getTaxAmount();
    $totalWithoutTax = $totale - $vatAmount;



    //template_stampa
    if($type=="fatture"){
      $data["template_stampa"] = $this->getConfig("winddoc/fatture/fatture_template",$order->getStoreId());
      $data["dicitura_invoice"] = "Ordine Numero ".$order->getIncrementId();
    }
    if($type=="ordini"){
      $data["template_stampa"] = $this->getConfig("winddoc/ordini/ordini_template",$order->getStoreId());
      $data["dicitura_quote"] = "Ordine Numero ".$order->getIncrementId();
    }
    if($type=="ricevute"){
      $data["template_stampa"] = $this->getConfig("winddoc/ricevute/ricevute_template",$order->getStoreId());
      $data["dicitura_invoice"] = "Ordine Numero ".$order->getIncrementId();
    }

    /* Differenti impostazioni per la generazione della fattura */
    //INPS - cassa/rivalsa
    //$data["cassa_rivalsa"] = 0;                     /* Valori permessi : ( 0 : Abilitata - 1 : Disabilitata)*/
    //$data["rivalsa_inps"] = 0.0;                    /* Valori permessi Float : indicare la percenutale di rivalsa INPS */
    //$data["cassa_previdenza"] = 0.0;                /* Valori permessi Float : indicare la percenutale di cassa previdenza */

    //Ritenuta d'acconto
    //$data["ritenuta_acconto_enable"] = 0;           /* Valori permessi : ( 0 : Abilitata - 1 : Disabilitata)*/
    //$data["ritenuta_acconto"] = 0.0;                /* Valori permessi Float : indicare la percenutale della ritenuta */
    //$data["ritenuta_acconto_su_imponibile"] = 0.0;  /* Valori permessi Float : indicare la percenutale da applicare al totale dell'imponibile*/


    //Altra ritenuta
    //$data["altra_ritenuta_enable"] = 0;             /* Valori permessi : ( 0 : Abilitata - 1 : Disabilitata)*/
    //$data["altra_ritenuta"] = 0.0;                  /* Valori permessi Float : indicare la percenutale della ritenuta */

    $iva_name = "";
    $iva_importo = "";
    $data["prodotto"] = array();
    $totale_calcolo = 0;
    foreach ($order->getAllItems() as $item){
      $prodotto = array();
      $qty = 0;
      if($type == 'ordini'){
        $qty = $item->getQtyOrdered();
      }
      if($type == 'fatture' || $type == 'ricevute'){
          $qty = $item->getQtyOrdered() - $item->getQtyCanceled();
      }


      if($qty>0){
        $prodotto["quantita"] = $qty;
        $prodotto["prezzo_netto"] = $item->getBasePrice();
        $vatCode = $item->getTaxPercent();

        if($item->getProduct()->isConfigurable()){
            $codine_prodotto = $item->getProductOptions()['simple_sku'];
            $descrizione_prodotto = $item->getProductOptions()['simple_name'];
        }else{
            $codine_prodotto = $item->getSku();
            $descrizione_prodotto = $item->getName();
        }
        $prodotto["codice"] = $codine_prodotto;
        $prodotto["nome"] = $descrizione_prodotto;

        if( strlen( $prodotto["codice"]) > 35) { //Per fattura elettronica
          $prodotto["nome"] = "Cod.".$prodotto["codice"]." - ".  $prodotto["nome"];

          $prodotto["codice"] = substr($prodotto["codice"],0,35);
        }

        $sconto = 0;
        if($item->getBaseDiscountAmount()>0){
          $sconto = (1-($item->getBaseRowTotalInclTax()-$item->getBaseDiscountAmount())/$item->getBaseRowTotalInclTax())*100;
        }

        $prodotto["sconto"] = $sconto;
        $prodotto["iva_importo"] = $vatCode;
        $iva_importo = $vatCode;
        $prodotto["importo_totale"] =$item->getBaseRowTotalInclTax()-$item->getBaseDiscountAmount();

        $totale_calcolo = $totale_calcolo  + $prodotto["importo_totale"];

        $productId = $item->getProductId();
        $_product = Mage::getModel('catalog/product')->load($productId);
        $taxClassId = $_product->getTaxClassId();
        $taxClass = Mage::getModel('tax/class')->load($taxClassId);
        $prodotto["iva_name"] = $taxClass->getClassName();
        $iva_name = $taxClass->getClassName();
        $prodotto["tipo_riga"] = 0; //TIpo riga prodotto
        $prodotto["unita_misura"] = "pz";


        if($type=="fatture" || $type=="ricevute"){
          if(Mage::helper('winddocapp')->getConfig("winddoc/fatture/magazzino")==1){
            $prodotto["scarica_da_magazzino"] = 1;
          }
        }
        if($type=="ordini"){
          if(Mage::helper('winddocapp')->getConfig("winddoc/ordini/magazzino")==1){
            $prodotto["scarica_da_magazzino"] = 1;
          }
        }

        $data["prodotto"][] = $prodotto;

      }
    }

    //Costo spedizione come servizio
    if($order->getShippingAmount() != 0){
      $prodotto = array();
      $prodotto["codice"] = "";
      $prodotto["nome"] = $order->getShippingDescription();
      $prodotto["prezzo_netto"] = $order->getShippingAmount();
      $prodotto["iva_importo"] = ($order->getShippingTaxAmount() / $order->getShippingAmount() * 100);
      if($prodotto["iva_importo"]==$iva_importo){
        $prodotto["iva_name"] = $iva_name;
      }
      $prodotto["importo_totale"] = $order->getShippingInclTax();
      $totale_calcolo = $totale_calcolo  + $prodotto["importo_totale"];
      $sconto = 0;
      if($order->getShippingDiscountAmount()>0){
        $sconto = (1-($order->getShippingInclTax()-$item->getShippingDiscountAmount())/$item->getShippingInclTax())*100;
      }
      $prodotto["sconto"] = $sconto;
      $prodotto["quantita"] = "1";
      $prodotto["tipo_riga"] = 2; //TIpo riga servizio
      $data["prodotto"][] = $prodotto;
    }



    //Mancano le spese aggiuntive, tipo contrassegno

    $totale = $order->getGrandTotal();
    $data["scadenza"] = array();
    $data["scadenza"][0]["ammontare"] = $totale;
    $data["scadenza"][0]["termini"] = "0"; //Immediato
    $data["scadenza"][0]["scadenza"] = time();
    if($type == 'fatture'){
      $data["scadenza"][0]["id_conto"] = Mage::helper('winddocapp')->getConfig("winddoc/fatture/pagamento");
      if($data["scadenza"][0]["id_conto"]!="0"){
        $data["scadenza"][0]["data_saldo"] = time();
      }
    }
    if($type == 'ricevute'){
      $data["scadenza"][0]["id_conto"] = Mage::helper('winddocapp')->getConfig("winddoc/ricevute/pagamento");
      if($data["scadenza"][0]["id_conto"]!="0"){
        $data["scadenza"][0]["data_saldo"] = time();
      }
    }

    //Mancano i costi aggiuntivi, tipo costo pagamento eccc...
    //Vediamo il totale della fattura, e se diverso dalla somma dei prodotti facciamo un prodotto aggiuntivo
    if($totale_calcolo<$totale){
      $resto = $totale-$totale_calcolo;

      $prodotto = array();
      $prodotto["codice"] = "";
      $prodotto["nome"] = "Altri Servizi";
      $prodotto["prezzo_netto"] = round($resto/(1+($iva_importo/100)),2);
      $prodotto["iva_importo"] = $iva_importo;
      $prodotto["iva_name"] = $iva_name;
      $prodotto["importo_totale"] = $resto;

      $prodotto["sconto"] = 0;
      $prodotto["quantita"] = "1";
      $prodotto["tipo_riga"] = 2; //TIpo riga servizio
      $data["prodotto"][] = $prodotto;

      //Che iva prendo?
    }


    return $data;

  }


  public function aggiungiSincroCustomer($customer_id,$id_customer_winddoc){
    $resource = Mage::getSingleton('core/resource');
    $writeConnection = $resource->getConnection('core_write');
    $query = "INSERT INTO ".$resource->getTableName('winddoc_sinc_customer')." (data_creazione,data_modifica,customer_id,id_customer_winddoc)   VALUES (NOW(),NOW(),'".$customer_id."','".$id_customer_winddoc."')";
    $writeConnection->query($query);
  }

  public function dettaglioSincroCustomer($customer_id){
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');

    $query = "SELECT * FROM ".$resource->getTableName('winddoc_sinc_customer')." WHERE customer_id = '".$customer_id."'";
    $results = $readConnection->fetchAll($query);
    if(count($results)>0){
      return $results[0];
    }
    return false;
  }

  public function aggiungiSincroOrdine($sales_flat_order_id){
    $resource = Mage::getSingleton('core/resource');
    $writeConnection = $resource->getConnection('core_write');
    $query = "INSERT INTO ".$resource->getTableName('winddoc_sinc_order')." (data_creazione,data_modifica,sales_flat_order_id)   VALUES (NOW(),NOW(),'".$sales_flat_order_id."')";
    $writeConnection->query($query);
  }

  public function aggiungiWinDocToOrder($sales_flat_order_id,$id_invoice_winddoc,$url_invoice_winddoc){
    $resource = Mage::getSingleton('core/resource');
    $writeConnection = $resource->getConnection('core_write');
    $query = "UPDATE ".$resource->getTableName('winddoc_sinc_order')." set id_invoice_winddoc = '".$id_invoice_winddoc."', url_invoice_winddoc = '".$url_invoice_winddoc."' WHERE sales_flat_order_id = '".$sales_flat_order_id."'";
    $writeConnection->query($query);
  }

  public function aggiungiWinDocOrderToOrder($sales_flat_order_id,$id_ordine_winddoc,$url_ordine_winddoc){
    $resource = Mage::getSingleton('core/resource');
    $writeConnection = $resource->getConnection('core_write');
    $query = "UPDATE ".$resource->getTableName('winddoc_sinc_order')." set id_ordine_winddoc = '".$id_ordine_winddoc."', url_ordine_winddoc = '".$url_ordine_winddoc."' WHERE sales_flat_order_id = '".$sales_flat_order_id."'";
    $writeConnection->query($query);
  }

  public function dettaglioOrdine($sales_flat_order_id = ""){
    $resource = Mage::getSingleton('core/resource');
    $readConnection = $resource->getConnection('core_read');

    $query = "SELECT * FROM ".$resource->getTableName('winddoc_sinc_order')." WHERE sales_flat_order_id = '".$sales_flat_order_id."'";
    $results = $readConnection->fetchAll($query);
    if(count($results)>0){
      return $results[0];
    }
    return false;
  }

  public function array_to_string($arr){
    $ret = $arr;
    if(is_array($arr)){
      $ret = implode(' ', $arr);
    }
    return $ret;
  }

}



class WindDocTalker
{
    private $url;
    private $soapclient;
    private $sessionId;
    private $token_app = "9bf918870cb006ebb2a831a1e9e689657d5164f3e7e40add00bbfb743434c52f";

    function __construct(){

      $this->url = 'https://app.winddoc.com/v1/api.php?wsdl';
      $this->soapclient = new SoapClient(null,
                                         array('location' => $this->url,
                                         'uri'            => $this->url,
                                         'soap_version'   => SOAP_1_1,
                                         'trace'          => 1,
                                         'exceptions'     => 0
                                        ));
    }


  public function sendDocument($data,$tipo){
    if($this->Login()){

      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($this->paseData($data),  'params'),
      );
      if($tipo=="fatture"){
        $ret = $this->__call("fatture_aggiungi", $args);
        return $ret;
      }
      if($tipo=="ricevute"){
        $ret = $this->__call("ricevute_aggiungi", $args);
        return $ret;
      }
      if($tipo=="ordini"){
        $ret = $this->__call("ordini_aggiungi", $args);
        return $ret;
      }
      $this->Close();
    }
  }

  public function cercaCustomer($q){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($q,  'term'),
        new SoapParam("1",  'pagina'),
      );

      $ret = $this->__call("contatti_search", $args);

      $this->Close();
      return $ret;


    }
  }

  public function aggiungiModificaCustomer($data){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($this->paseData($data),  'params'),
      );

      $ret = $this->__call("contatti_aggiungimodifica", $args);

      $this->Close();
      return $ret;


    }
  }

  public function aggiungiCustomer($data){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($this->paseData($data),  'params'),
      );

      $ret = $this->__call("contatti_aggiungi", $args);

      $this->Close();
      return $ret;


    }
  }

  public function getConti(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("settings_conti_lista", $args);
      $this->Close();
      return $ret;
    }
  }


  public function getTemplateRicevute(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("ricevute_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }


  public function getTemplateQuote(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("ordini_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }

  public function getTemplateInvoice(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("fatture_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }


  public function paseData($data){
    $args = array();
    foreach ($data as $key => $value) {
      if(is_array($value)){
        $args[] = new SoapParam($this->paseData($value),  $key);
      }else{
        $args[] = new SoapParam($value,  $key);
      }
    }

    return $args;
  }

  public function Login(){
    $args = array(
     'token' => Mage::helper('winddocapp')->getConfig("winddoc/accesso/token"),
     'token_app' => $this->token_app
    );
    $this->sessionId = $this->__call("login", $args);

    if($this->sessionId!=""){
      return true;
    }
    return false;
  }

  public function Close(){

    $args = array(
     'id_session' => $this->sessionId
    );

    $this->__call("close", $args);
  }


  public function __call($method, $args){
     //return call_user_func_array(array($this->soapclient, $method), $args);
     $response = $this->soapclient->__soapCall($method, $args);
     if(is_object($response) && get_class($response)=="SoapFault"){
       return array();
     }
     return $response;

  }


}
